﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpenQA.Selenium.Appium.Windows;
using OpenQA.Selenium.Interactions.Internal;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace QyClientTest
{
    [TestClass]
    public class PlayerPageScenarios : QyClientTestBase  // 子类型需要设置为 public，否则“测试资源管理器”中看不到
    {
        [ClassInitialize] //每个单元测试方法执行前，调用的初始化方法
        public static void Setup(TestContext context)
        {
            BaseSetup(context);
        }

        [ClassCleanup] //每个单元测试方法执行完成后，调用的清理方法
        public static void TearDown()
        {
            BaseTearDown();
        }

        bool isPlaying = false;

        [TestMethod]
        public void SliderClick()
        {

            if (isPlaying == false)
            {
                // 先从 app首页，随机播放一个视频，跳转到播放页
                PlayBRandom();
                
                Thread.Sleep(TimeSpan.FromSeconds(3));
                isPlaying = true;
            }
            
            ShowControls();

            //元素需要在页面中显示，如 Visibility="Collapsed" 则获取不到
            WindowsElement slider = QyClientSession.FindElementByAccessibilityId("slider_position"); //进度条

            Assert.IsNotNull(slider);

            //视频进度条拖动到中间位置
            QyClientSession.Mouse.MouseMove(slider.Coordinates, slider.Size.Width / 2, 0); 
            
            // seek进度
            slider.Click();
            Thread.Sleep(TimeSpan.FromSeconds(3));

            //随机播放页面中的一个视频
            PlayBRandom();

            Thread.Sleep(TimeSpan.FromSeconds(5));

            // 递归调用，在当前页面切换选集播放
            SliderClick();
        }

        /// <summary>
        /// 播放当前页面中的任意一个 B 对象
        /// </summary>
        void PlayBRandom()
        {
            var list = QyClientSession.FindElementsByName("QyClient._3._0.Model._B");

            if (list.Count > 0)
            {
                int min = isPlaying ? 0 : 30; //在app首页时，播放 30以后的 B对象

                int index = new Random().Next(min, list.Count - 1);

                WindowsElement e = list.ElementAt(index);
                e.Click();
            }
            Assert.AreNotEqual(list.Count, 0);

            Thread.Sleep(3000);
        }

        /// <summary>
        /// 显示播控栏，否则播控按钮获取不到
        /// </summary>
        void ShowControls()
        {
            WindowsElement win = QyClientSession.FindElementByAccessibilityId("mediaPlayer");
            win.Click();
            Thread.Sleep(500);
        }
    }
}
