﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpenQA.Selenium.Appium.Windows;
using OpenQA.Selenium.Remote;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace QyClientTest
{
    public class QyClientTestBase
    {
        // Note: append /wd/hub to the URL if you're directing the test at Appium
        protected const string WindowsApplicationDriverUrl = "http://127.0.0.1:4723";

        protected static WindowsElement Hanburg;

        protected static WindowsElement BackButton;
        protected static WindowsDriver<WindowsElement> QyClientSession;
        protected static string OriginalCalculatorMode;

        public static void BaseSetup(TestContext context)
        {
            if (QyClientSession == null)
            {
                // 启动爱奇艺 app
                DesiredCapabilities appCapabilities = new DesiredCapabilities();
                appCapabilities.SetCapability("app", "0C72C7CD.Beta_atj5cpqqdhzyp!App");// "0C72C7CD.61910B44FC902_atj5cpqqdhzyp!App");
                appCapabilities.SetCapability("deviceName", "WindowsPC");
                QyClientSession = new WindowsDriver<WindowsElement>(new Uri(WindowsApplicationDriverUrl), appCapabilities);
                Assert.IsNotNull(QyClientSession);
                QyClientSession.Manage().Timeouts().ImplicitlyWait(TimeSpan.FromSeconds(3));
                
                Hanburg = QyClientSession.FindElementByName("Menu");

                // 已经在播放页时
                //BackButton = QyClientSession.FindElementByAccessibilityId("Back");
            }

            // 在首页时，汉堡按钮显示；在播放页时，Back按钮显示
            Assert.IsNotNull(Hanburg);
        }

        public static void BaseTearDown()
        {
            if (QyClientSession != null)
            {
                Hanburg = null;
                QyClientSession.Dispose();
                QyClientSession = null;
            }
        }        
    }
}

/* 先启动 C:\Program Files (x86)\Windows Application Driver\WinAppDriver.exe，否则会抛异常
  Unexpected error. System.Net.WebException: 无法连接到远程服务器 ---> System.Net.Sockets.SocketException: 由于目标计算机积极拒绝，无法连接。 127.0.0.1:4723
  在 System.Net.Sockets.Socket.DoConnect(EndPoint endPointSnapshot, SocketAddress socketAddress)
  在 System.Net.ServicePoint.ConnectSocketInternal(Boolean connectFailure, Socket s4, Socket s6, Socket& socket, IPAddress& address, ConnectSocketState state, IAsyncResult asyncResult, Exception& exception)
  --- 内部异常堆栈跟踪的结尾 ---
  在 OpenQA.Selenium.Appium.Service.AppiumCommandExecutor.Execute(Command commandToExecute)
  在 OpenQA.Selenium.Remote.RemoteWebDriver.Execute(String driverCommandToExecute, Dictionary`2 parameters)
*/
